require "defines"
require "util"

local defaultGuiSettings = { displayCount = 9, page = 1}


--Called if tech is unlocked
function init(player, oldGuiSettings)
	debugLog("Init: " .. player.name)
	if player.gui.left.fatController ~= nil then
		player.gui.left.fatController.destroy()
	end
	
	local guiSettings = {}
	
	if oldGuiSettings == nil then
		guiSettings = util.table.deepcopy(defaultGuiSettings)
		guiSettings.stationFilterList = buildStationFilterList(glob.trains)
	else
		guiSettings = oldGuiSettings
	end
	
	if glob.character == nil then
		glob.character = {}
	end
	
	--destroyGui(guiSettings.fatControllerGui)
	--destroyGui(guiSettings.fatControllerButtons)
	
		
	debugLog("create guis")
	if player.gui.left.fatController == nil then
		guiSettings.fatControllerGui = player.gui.left.add({ type="flow", name="fatController", direction="vertical"})--, style="fatcontroller_thin_flow"}) --caption="Fat Controller", 
	else
		guiSettings.fatControllerGui = player.gui.left.fatController
	end
	if player.gui.top.fatControllerButtons == nil then
		guiSettings.fatControllerButtons = player.gui.top.add({ type="flow", name="fatControllerButtons", direction="horizontal", style="fatcontroller_thin_flow"})
	else
		guiSettings.fatControllerButtons = player.gui.top.fatControllerButtons
	end
	--game.players[1].gui.top.add({type="button", name="toggleTrainInfo", caption=game.gettext("text-trains") .. " +", style="fatcontroller_button_style"})
	
	 --game.players[1].gui.left.fatController text = {"msg-intro"} caption = {"text-trains"} .. " +"
	if guiSettings.fatControllerButtons.toggleTrainInfo == nil then
		guiSettings.fatControllerButtons.add({type="button", name="toggleTrainInfo", caption = {"text-trains-collapsed"}, style="fatcontroller_button_style"})
	end
	
	
	
	if guiSettings.fatControllerGui.trainInfo ~= nil then
		--guiSettings.fatControllerGui.trainInfo.destroy()
		--glob.fatControllerGui.add({ type="frame", name="trainInfo", direction="vertical", style="fatcontroller_thin_frame"})
		newTrainInfoWindow(guiSettings)
		updateTrains(glob.trains)
		--refreshTrainInfoGui(glob.trains, glob.fatControllerGui.trainInfo, glob.guiSettings, game.players[1].character)
	end

		
	if glob.trains == nil then
		glob.trains = {}
	end
	
	guiSettings.pageCount = getPageCount(glob.trains, guiSettings) 
	
	filterTrainInfoList(glob.trains, guiSettings.activeFilterList)
	
	updateTrains(glob.trains)
	refreshTrainInfoGui(glob.trains, guiSettings, player.character)
	
	return guiSettings
end

onTickAfterUnlocked = function(event)
	-- if event.tick%10==9  then
		-- for i,player in ipairs(game.players) do
			-- if glob.character[i] == nil and game.players[1].opened ~= nil and game.players[1].opened.valid and isTrainType(game.players[1].opened.type) and game.players[1].opened.train ~= nil and glob.guisettings[i].fatControllerButtons.toggleTrain == nil then
				-- if trainInList(glob.trains, game.players[1].opened.train) then
					-- glob.guisettings[i].fatControllerButtons.add({ type="button", name="toggleTrain", caption={"text-removetrain"}, style="fatcontroller_selected_button"})
				-- else
					-- glob.guisettings[i].fatControllerButtons.add({ type="button", name="toggleTrain", caption={"text-addtrain"}, style="fatcontroller_selected_button"})
				-- end
				-- --addNewTrainGui(glob.fatControllerButtons, game.players[1].opened.train)
			-- elseif (game.players[1].opened == nil or glob.character ~= nil) and glob.guisettings[i].fatControllerButtons.toggleTrain ~= nil  then
				-- glob.guisettings[i].fatControllerButtons.toggleTrain.destroy()
			-- end
		-- end
	-- end
	
	if event.tick%60==13 then
		if glob.guiSettings == nil then
			loadGame()
		end
		local updateGui = false
		for i,guiSettings in ipairs(glob.guiSettings) do
			if guiSettings.fatControllerGui ~= nil and guiSettings.fatControllerGui.trainInfo ~= nil then
				updateGui = true
			end
		end
		if updateGui then
			debugLog("updateGUI")
			--updateInventoryCount(glob.trains)
			updateTrains(glob.trains)
			refreshAllTrainInfoGuis(glob.trains, glob.guiSettings, game.players)
			for i,player in ipairs(game.players) do
				--refreshTrainInfoGui(glob.trains, glob.guiSettings[i], player.character)
				glob.guiSettings[i].pageCount = getPageCount(glob.trains, glob.guiSettings[i]) 
			end
		end
	end
	
	for i,guiSettings in ipairs(glob.guiSettings) do
		if guiSettings.followEntity ~= nil then -- Are we in remote camera mode?
			if not guiSettings.followEntity.valid  or game.players[i].vehicle == nil then
				swapPlayer(game.players[i], glob.character[i])
				if guiSettings.fatControllerButtons ~= nil and guiSettings.fatControllerButtons.returnToPlayer ~= nil then
					guiSettings.fatControllerButtons.returnToPlayer.destroy()
				end
				
				if not guiSettings.followEntity.valid then
					removeTrainInfoFromEntity(glob.trains, guiSettings.followEntity)
					newTrainInfoWindow(guiSettings)
					refreshTrainInfoGui(glob.trains, guiSettings, game.players[i].character)
					
				end
				
				glob.character[i] = nil
				guiSettings.followEntity = nil
				
			elseif glob.character[i] ~= nil and glob.character[i].valid and guiSettings.fatControllerButtons ~= nil and guiSettings.fatControllerButtons.returnToPlayer == nil then
				guiSettings.fatControllerButtons.add({ type="button", name="returnToPlayer", caption={"text-player"}, style = "fatcontroller_selected_button"})
				--game.players[1].teleport(glob.followEntity.position)
			elseif glob.character[i] ~= nil and not glob.character[i].valid  then
				game.setgamestate({gamefinished=true, playerwon=false})
			end
		end
	end
	

	
	--if event.tick%30==4 and glob.fatControllerGui.trainInfo ~= nil then
		--refreshTrainInfoGui(glob.trains, glob.fatControllerGui.trainInfo, glob.guiSettings, game.players[1].character)
	--end
end


-- game.oninit(function()
	-- debugLog("init")
-- end)

loadGame = function ()
	-- debugLog("LOADGAME!")
	-- if glob.tech == nil then
		-- glob.tech = game.players[1].force.technologies["rail-signals"]
		
	-- end
	-- glob.unlocked = glob.tech.researched
	
	if glob.unlocked then
		debugLog("Unlocked!")
		if glob.guiSettings == nil then glob.guiSettings = {} end
		
		for i,player in ipairs(game.players) do
			if glob.guiSettings[i] == nil then
				debugLog("Player: " .. i)
				glob.guiSettings[i] = init(player, glob.guiSettings[i])
			end
		end
		--game.onevent(defines.events.ontick, onTickAfterUnlocked)
	end
end

game.onevent(defines.events.onplayercreated, function(event)
	glob.guiSettings[event.playerindex] = init(game.players[event.playerindex], glob.guiSettings[i])
	
	-- if glob.unlocked then
		-- for i,player in ipairs(game.players) do
			-- if glob.guiSettings[i] == nil then
				 -- = 
			-- end
		-- end
	-- end
end)

onTickBeforeUnlocked = function(event)
	if not glob.unlocked then
		if event.tick%120==12 then
			if glob.tech == nil then
				glob.tech = game.players[1].force.technologies["rail-signals"]
			end
			if glob.tech ~= nil then
				glob.unlocked = glob.tech.researched
				if glob.unlocked then
					game.onevent(defines.events.ontick, onTickAfterUnlocked)
				end
			end
			
			--destroyGui(glob.fatControllerGui)
			--destroyGui(glob.fatControllerButtons)
		end
	end
end

game.onevent(defines.events.ontick,onTickBeforeUnlocked)



game.onload(loadGame)

function destroyGui(guiA)
	if guiA ~= nil and guiA.valid then
		guiA.destroy()
	end
end

function buildStationFilterList(trains)
	local newList = {}
	if trains ~= nil then
		for i, trainInfo in ipairs(trains) do
			-- if trainInfo.group ~= nil then
				-- newList[trainInfo.group] = true
			-- end
			if trainInfo.stations ~= nil then
				for station, value in pairs(trainInfo.stations) do
					debugLog(station)
					newList[station] = true
				end
			end
		end
	end
	return newList
end

function getLocomotives(train)
	if train ~= nil and train.valid then
		local locos = {}
		for i,carriage in ipairs(train.carriages) do
			if carriage ~= nil and carriage.valid and isTrainType(carriage.type) then
				table.insert(locos, carriage)
			end
		end
		return locos
	end
end

function getNewTrainInfo(train)
	if train ~= nil then
		local carriages = train.carriages
		if carriages ~= nil and carriages[1] ~= nil and carriages[1].valid then
			local newTrainInfo = {}
			newTrainInfo.train = train
			--newTrainInfo.firstCarriage = getFirstCarriage(train)
			newTrainInfo.locomotives = getLocomotives(train)
			
			--newTrainInfo.display = true
			return newTrainInfo
		end
	end
end

entityBuilt = function(event)
	local entity = event.createdentity
	if entity.type == "locomotive"  then --or entity.type == "cargo-wagon"
		getTrainInfoOrNewFromEntity(glob.trains, entity)
	end
end

game.onevent(defines.events.onbuiltentity, entityBuilt)
game.onevent(defines.events.onrobotbuiltentity, entityBuilt)

  -- -- normal state - following the path
  -- onthepath = 0,
  -- -- had path and lost it - must stop
  -- pathlost = 1,
  -- -- doesn't have anywhere to go
  -- noschedule = 2,
  -- -- has no path and is stopped
  -- nopath = 3,
  -- -- braking before the railSignal
  -- arrivesignal = 4,
  -- waitsignal = 5,
  -- -- braking before the station
  -- arrivestation = 6,
  -- waitstation = 7,
  -- -- switched to the manual control and has to stop
  -- manualcontrolstop = 8,
  -- -- can move if user explicitly sits in and rides the train
  -- manualcontrol = 9,
  -- -- train was switched to auto control but it is moving and needs to be stopped
  -- stopforautocontrol = 10

game.onevent(defines.events.ontrainchangedstate, function(event)
	debugLog("State Change - " .. game.tick)
	if not glob.unlocked then --This is retarded, just set the event on unlock
		return
	end
	
	local train = event.train
	local entity = train.carriages[1]
	local trainInfo = getTrainInfoOrNewFromEntity(glob.trains, entity)
	if trainInfo ~= nil then
		updateTrainInfo(trainInfo)
		refreshAllTrainInfoGuis(glob.trains, glob.guiSettings, game.players)
	end
end)

function getTrainInfoOrNewFromEntity(trains, entity)
	local trainInfo = getTrainInfoFromEntity(trains, entity)
	if trainInfo == nil then
		local newTrainInfo = getNewTrainInfo(entity.train)
		table.insert(glob.trains, newTrainInfo)
		return newTrainInfo
	else
		return trainInfo
	end
end

game.onevent(defines.events.onguiclick, function(event)
	local refreshGui = false
	local newInfoWindow = false
	local rematchStationList = false
	local guiSettings = glob.guiSettings[event.element.playerindex]
	local player = game.players[event.element.playerindex]
	
	-- if (event.element.name == "toggleTrain" and player.opened ~= nil and isTrainType(game.players[1].opened.type)) then
		-- --debugLog(game.players[1].opened.type)
		-- if trainInList(glob.trains, player.opened.train) then
			-- removeTrainInfoFromEntity(glob.trains, player.opened.train.carriages[1])
			-- rematchStationList = true
			-- --refreshTrainInfoGui(glob.trains, glob.fatControllerGui.trainInfo, glob.guiSettings)
			-- newInfoWindow = true
			-- refreshGui = true
			-- event.element.caption = {"text-addtrain"}
		-- else
			-- local newTrainInfo = getNewTrainInfo(game.players[1].opened.train)
			-- if newTrainInfo ~= nil then
				-- table.insert(glob.trains, newTrainInfo)
				-- --refreshTrainInfoGui(glob.trains, glob.fatControllerGui.trainInfo, glob.guiSettings)
				-- rematchStationList = true
				-- newInfoWindow = true
				-- refreshGui = true
				-- event.element.caption = {"text-removetrain"}
			-- end
		-- end
	-- else
	if event.element.name == "toggleTrainInfo" then
		if guiSettings.fatControllerGui.trainInfo == nil then
			--glob.fatControllerGui.add({ type="frame", name="trainInfo", direction="vertical", style="fatcontroller_thin_frame"})
			--newTrainInfoWindow(glob.fatControllerGui, glob.guiSettings)
			newInfoWindow = true
			--refreshTrainInfoGui(glob.trains, glob.fatControllerGui.trainInfo, glob.guiSettings)
			refreshGui = true
			event.element.caption = {"text-trains"}
		else
			guiSettings.fatControllerGui.trainInfo.destroy()
			event.element.caption = {"text-trains-collapsed"}
		end 
	elseif event.element.name == "returnToPlayer" then
		if glob.character[event.element.playerindex] ~= nil then
			if player.vehicle ~= nil then
				player.vehicle.passenger = nil
			end
			swapPlayer(player, glob.character[event.element.playerindex])
			glob.character[event.element.playerindex] = nil
			event.element.destroy()
			guiSettings.followEntity = nil 
		end
	-- elseif endsWith(event.element.name,"_removeTrain") then
		-- local trainInfo = getTrainInfoFromElementName(glob.trains, event.element.name)
		-- if trainInfo ~= nil then
			-- local elementName = event.element.name
			
			-- if guiSettings.followEntity ~= nil and guiSettings.followEntity.equals(trainInfo.train.carriages[1]) then --Go back to player
				-- if player.vehicle ~= nil then
					-- player.vehicle.passenger = nil
				-- end
				-- swapPlayer(player, glob.character[event.element.playerindex])
				-- if glob.fatControllerButtons.returnToPlayer ~= nil then
					-- glob.fatControllerButtons.returnToPlayer.destroy()
				-- end
				-- glob.character[event.element.playerindex] = nil
				-- guiSettings.followEntity = nil
			-- end
			
			-- guiSettings.fatControllerGui.trainInfo[trainInfo.guiName].destroy()
			-- removeTrainInfoFromElementName(glob.trains, elementName)
			
			-- --newTrainInfoWindow(glob.fatControllerGui, glob.guiSettings)
			-- --refreshTrainInfoGui(glob.trains, glob.fatControllerGui.trainInfo, glob.guiSettings)
			
			-- newInfoWindow = true
			-- refreshGui = true
			-- rematchStationList = true
		-- end
	elseif endsWith(event.element.name,"_toggleManualMode") then
		local trainInfo = getTrainInfoFromElementName(glob.trains, event.element.name)
		if trainInfo ~= nil and trainInfo.train ~= nil and trainInfo.train.valid then
			trainInfo.train.manualmode = not trainInfo.train.manualmode
			swapCaption(event.element, "ll", ">")
		end
	elseif endsWith(event.element.name,"_toggleFollowMode") then
		local trainInfo = getTrainInfoFromElementName(glob.trains, event.element.name)
		if trainInfo ~= nil and trainInfo.train ~= nil and trainInfo.train.valid then
			if glob.character[event.element.playerindex] == nil then --Move to train
				if trainInfo.train.carriages[1].passenger ~= nil then
					player.print({"msg-intrain"})
				else
					glob.character[event.element.playerindex] = player.character
					guiSettings.followEntity = trainInfo.train.carriages[1] -- HERE
					
					--fatControllerEntity = 
					swapPlayer(player,newFatControllerEntity(player.position))
					event.element.style = "fatcontroller_selected_button"
					trainInfo.train.carriages[1].passenger = player.character
				end
			elseif guiSettings.followEntity ~= nil and trainInfo.train ~= nil and trainInfo.train.valid then
				if player.vehicle ~= nil then
					player.vehicle.passenger = nil
				end
				if guiSettings.followEntity.equals(trainInfo.train.carriages[1]) or trainInfo.train.carriages[1].passenger ~= nil then --Go back to player
					swapPlayer(player, glob.character[event.element.playerindex])
					event.element.style = "fatcontroller_button_style"
					if guiSettings.fatControllerButtons ~= nil and guiSettings.fatControllerButtons.returnToPlayer ~= nil then
						guiSettings.fatControllerButtons.returnToPlayer.destroy()
					end
					glob.character[event.element.playerindex] = nil
					guiSettings.followEntity = nil
				else -- Go to different train
					
					guiSettings.followEntity = trainInfo.train.carriages[1] -- AND HERE
					event.element.style = "fatcontroller_selected_button"
					
					trainInfo.train.carriages[1].passenger = player.character
					--game.players[1].vehicle = trainInfo.train.carriages[1]
				end
			end
			
		end
	elseif event.element.name == "page_back" then
		if guiSettings.page > 1 then
			guiSettings.page = guiSettings.page - 1
			--glob.fatControllerGui.trainInfo.trainInfoControls.page_number.caption = glob.guiSettings.page
			--newTrainInfoWindow(glob.fatControllerGui, glob.guiSettings)
			--refreshTrainInfoGui(glob.trains, glob.fatControllerGui.trainInfo, glob.guiSettings)
			newInfoWindow = true
			refreshGui = true
		end
	elseif event.element.name == "page_forward" then
		if guiSettings.page < getPageCount(glob.trains, guiSettings) then
			guiSettings.page = guiSettings.page + 1
			--debugLog(glob.guiSettings.page)
			--newTrainInfoWindow(glob.fatControllerGui, glob.guiSettings)
			--refreshTrainInfoGui(glob.trains, glob.fatControllerGui.trainInfo, glob.guiSettings)
			newInfoWindow = true
			refreshGui = true
		end
	elseif event.element.name == "page_number" then
		togglePageSelectWindow(player.gui.center, guiSettings)
	elseif event.element.name == "pageSelectOK" then
		local gui = player.gui.center.pageSelect
		if gui ~= nil then
			
			local newInt = tonumber(gui.pageSelectValue.text)
			
			if newInt then
				if newInt < 1 then
					newInt = 1
				elseif newInt > 50 then
					newInt = 50
				end
				guiSettings.displayCount = newInt
				guiSettings.pageCount = getPageCount(glob.trains, guiSettings) 
				guiSettings.page = 1
				refreshGui = true
				newInfoWindow = true
			else
				player.print({"msg-notanumber"})
			end
			gui.destroy()
		end
	elseif event.element.name == "toggleStationFilter" then 
		guiSettings.stationFilterList = buildStationFilterList(glob.trains)
		toggleStationFilterWindow(player.gui.center, guiSettings)
	elseif event.element.name == "clearStationFilter" or event.element.name == "stationFilterClear" then
		if guiSettings.activeFilterList ~= nil then
			guiSettings.activeFilterList = nil
			
			rematchStationList = true
			newInfoWindow = true
			refreshGui = true
		end
		if player.gui.center.stationFilterWindow ~= nil then
			player.gui.center.stationFilterWindow.destroy()
		end
	elseif event.element.name == "stationFilterOK" then
		local gui = player.gui.center.stationFilterWindow
		if gui ~= nil and gui.checkboxGroup ~= nil then
			local newFilter = {}
			local listEmpty = true
			for station,value in pairs(guiSettings.stationFilterList) do
				local checkboxA = gui.checkboxGroup[station .. "_stationFilter"]
				if checkboxA ~= nil and checkboxA.state then
					listEmpty = false
					--debugLog(station)
					newFilter[station] = true
				end
			end
			if not listEmpty then
				guiSettings.activeFilterList = newFilter
				
				--glo.filteredTrains = buildFilteredTrainInfoList(glob.trains, glob.guiSettings.activeFilterList)
			else
				guiSettings.activeFilterList = nil
			end
			
			gui.destroy()
			guiSettings.page = 1
			rematchStationList = true
			newInfoWindow = true
			refreshGui = true
		end
	elseif endsWith(event.element.name,"_stationFilter") then
		local stationName = string.gsub(event.element.name, "_stationFilter", "")
		if event.element.state then
			if guiSettings.activeFilterList == nil then
				guiSettings.activeFilterList = {}
			end
		
			guiSettings.activeFilterList[stationName] = true
		elseif guiSettings.activeFilterList ~= nil then
			guiSettings.activeFilterList[stationName] = nil
			if tableIsEmpty(guiSettings.activeFilterList) then
				guiSettings.activeFilterList = nil
			end
		end
		--debugLog(event.element.name)
		guiSettings.page = 1
		rematchStationList = true
		newInfoWindow = true
		refreshGui = true
	end
	
	if rematchStationList then
		filterTrainInfoList(glob.trains, guiSettings.activeFilterList)
		guiSettings.pageCount = getPageCount(glob.trains, guiSettings) 
	end
	
	if newInfoWindow then
		newTrainInfoWindow(guiSettings)
	end
	
	if refreshGui then
		refreshTrainInfoGui(glob.trains, guiSettings, player.character)
	end
	

end)

-- function swapStyle(guiElement, styleA, styleB)
	-- if guiElement ~= nil and styleA ~= nil and styleB ~= nil then
		-- if guiElement.style == styleA then
			-- guiElement.style = styleB
		-- elseif guiElement.style == styleB then
			-- guiElement.style = styleA
		-- end
	-- end
-- end

function swapCaption(guiElement, captionA, captionB)
	if guiElement ~= nil and captionA ~= nil and captionB ~= nil then
		if guiElement.caption == captionA then
			guiElement.caption = captionB
		elseif guiElement.caption == captionB then
			guiElement.caption = captionA
		end
	end

end

function tableIsEmpty(tableA)
	if tableA ~= nil then
		for i,v in pairs(tableA) do
			return false
		end
	end
	return true
end

function toggleStationFilterWindow(gui, guiSettings)
	if gui ~= nil then
		if gui.stationFilterWindow == nil then
			--local sortedList = table.sort(a)
			local window = gui.add({type="frame", name="stationFilterWindow", caption={"msg-stationFilter"}, direction="vertical" }) --style="fatcontroller_thin_frame"}) 
			window.add({type="table", name="checkboxGroup", colspan=3})
			for name, value in pairsByKeys(guiSettings.stationFilterList) do
				if guiSettings.activeFilterList ~= nil and guiSettings.activeFilterList[name] then 
					window.checkboxGroup.add({type="checkbox", name=name .. "_stationFilter", caption=name, state=true}) --style="filter_group_button_style"})
				else
					window.checkboxGroup.add({type="checkbox", name=name .. "_stationFilter", caption=name, state=false}) --style="filter_group_button_style"})
				end
				
				
			end
			window.add({type="flow", name="buttonFlow"})
			window.buttonFlow.add({type="button", name="stationFilterClear", caption={"msg-Clear"}})
			window.buttonFlow.add({type="button", name="stationFilterOK", caption={"msg-OK"}})
			
		else
			gui.stationFilterWindow.destroy()
		end
	end
end



function togglePageSelectWindow(gui, guiSettings)
	if gui ~= nil then
		if gui.pageSelect == nil then
			local window = gui.add({type="frame", name="pageSelect", caption={"msg-displayCount"}, direction="vertical" }) --style="fatcontroller_thin_frame"}) 
			window.add({type="textfield", name="pageSelectValue", text=guiSettings.displayCount .. ""})
			window.pageSelectValue.text = guiSettings.displayCount .. ""
			window.add({type="button", name="pageSelectOK", caption={"msg-OK"}})
		else
			gui.pageSelect.destroy()
		end
	end
end

function getPageCount(trains, guiSettings)
	local trainCount = 0
	for i,trainInfo in ipairs(trains) do
		if guiSettings.activeFilterList == nil or trainInfo.matchesStationFilter then
			trainCount = trainCount + 1
		end
	end
	return math.floor((trainCount - 1) / guiSettings.displayCount) + 1 
end

local onEntityDied = function (event)
	local trainInfo = getTrainInfoFromEntity(glob.trains, event.entity)
	if trainInfo ~= nil then
		for i, player in ipairs(game.players) do
			local guiSettings = glob.guiSettings[i]
			if guiSettings.followEntity ~= nil and guiSettings.followEntity.equals(trainInfo.train.carriages[1]) then --Go back to player
				if game.players[i].vehicle ~= nil then
					game.players[i].vehicle.passenger = nil
				end
				
				swapPlayer(game.players[i], glob.character[i])
				
				if guiSettings.fatControllerButtons.returnToPlayer ~= nil then
					guiSettings.fatControllerButtons.returnToPlayer.destroy()
				end
				
				glob.character[i] = nil
				guiSettings.followEntity = nil
			end
		end
		
		removeTrainInfoFromEntity(glob.trains, entity)
		
		refreshAllTrainInfoGuis(glob.trains, glob.guiSettings, game.players)
	end
end

function refreshAllTrainInfoGuis(trains, guiSettings, players)
	for i,player in ipairs(players) do
		--local trainInfo = guiSettings[i].fatControllerGui.trainInfo
		if guiSettings[i].fatControllerGui.trainInfo ~= nil then
			guiSettings[i].fatControllerGui.trainInfo.destroy()
			newTrainInfoWindow(guiSettings[i])
			refreshTrainInfoGui(trains, guiSettings[i], player.character)
		end
	end
end

game.onevent(defines.events.onentitydied, onEntityDied)

game.onevent(defines.events.onpreplayermineditem, onEntityDied)

function isUnlocked(technologies)
	return technologies["rail-signals"].researched 
end

function swapPlayer(player, character)
	--player.teleport(character.position)
	if player.character ~= nil and player.character.valid and player.character.name == "fatcontroller" then
		player.character.destroy()
	end
	player.character = character
end

function isTrainType(type)
	if type == "locomotive" then
		return true
	end
	return false
end

function getTrainInfoFromElementName(trains, elementName)
	for i, trainInfo in ipairs(trains) do
		if trainInfo ~= nil and trainInfo.guiName ~= nil and startsWith(elementName, trainInfo.guiName .. "_") then
			return trainInfo
		end
	end
end


function getTrainInfoFromEntity(trains, entity)
	if trains ~= nil then
		for i, trainInfo in ipairs(trains) do
			if trainInfo ~= nil and trainInfo.train ~= nil and trainInfo.train.valid and entity.equals(trainInfo.train.carriages[1]) then
				return trainInfo
			end
		end
	end
end

function removeTrainInfoFromElementName(trains, elementName)
	for i, trainInfo in ipairs(trains) do
		if trainInfo ~= nil and trainInfo.guiName ~= nil and startsWith(elementName, trainInfo.guiName .. "_") then
			table.remove(trains, i)
			return
		end
	end
end

function removeTrainInfoFromEntity(trains, entity)
	for i, trainInfo in ipairs(trains) do
		if trainInfo ~= nil and trainInfo.train ~= nil and trainInfo.train.valid and trainInfo.train.carriages[1].equals(entity) then
			table.remove(trains, i)
			return
		end
	end
end

function getHighestInventoryCount(trainInfo)
	local inventry = nil
	
	if trainInfo ~= nil and trainInfo.train ~= nil and trainInfo.train.valid and trainInfo.train.carriages ~= nil then
		local itemsCount = 0
		local largestItem = {}
		local items = {}
		
		
		
		for i, carriage in ipairs(trainInfo.train.carriages) do
			if carriage ~= nil and carriage.valid and carriage.type == "cargo-wagon" then
				
				local inv = carriage.getinventory(1)
				local contents = inv.getcontents()
				for name, count in pairs(contents) do
					if items[name] ~= nil then
						items[name] = items[name] + count
					else
						items[name] = count
						itemsCount = itemsCount + 1
					end
					if largestItem.count == nil or largestItem.count < items[name] then
						largestItem.name = name
						largestItem.count = items[name]
					end
				end
			end

		end
		
		if largestItem.name ~= nil then
			--local displayName = game.getlocaliseditemname(largestItem.name)
			-- if startsWith(displayName, "Unknown-key") then
				-- displayName = largestItem.name
			-- end
			local displayName = largestItem.name
			inventory = displayName .. ": " .. largestItem.count
			if itemsCount > 1 then
				inventory = inventory .. "..."
			end
		else
			inventory = ""
		end
	end
	
	return inventory
end

function updateInventoryCount(trains)
	for i, trainInfo in ipairs(trains) do
		if trainInfo.train ~= nil and trainInfo.train.valid and trainInfo.train.speed == 0 then
			local tempInventory = getHighestInventoryCount(trainInfo)
			if tempInventory ~= nil then
				trainInfo.inventory = tempInventory
			end
		end
	end
end

function newFatControllerEntity(position)
	game.createentity({name="fatcontroller", position=position, force=game.forces.player})
	local entities = game.findentitiesfiltered({area={{position.x, position.y},{position.x, position.y}}, name="fatcontroller"})
	if entities[1] ~= nil then
		return entities[1]
	end
end

function newTrainInfoWindow(guiSettings)
	
	if guiSettings == nil then
		guiSettings = util.table.deepcopy(defaultGuiSettings)
	end
	local gui = guiSettings.fatControllerGui
	if gui ~= nil and gui.trainInfo ~= nil then
		gui.trainInfo.destroy()
	end
	
	local newGui
	
	if gui ~= nil and gui.trainInfo ~= nil then
		newGui = gui.trainInfo
	else
		newGui = gui.add({ type="flow", name="trainInfo", direction="vertical", style="fatcontroller_thin_flow"})
	end
	
	if newGui.trainInfoControls == nil then
		newGui.add({type = "frame", name="trainInfoControls", direction="horizontal", style="fatcontroller_thin_frame"})
	end
	
	if newGui.trainInfoControls.pageButtons == nil then
		newGui.trainInfoControls.add({type = "flow", name="pageButtons",  direction="horizontal", style="fatcontroller_button_flow"})
	end
	
	if newGui.trainInfoControls.pageButtons.page_back == nil then
		
		if guiSettings.page > 1 then
			newGui.trainInfoControls.pageButtons.add({type="button", name="page_back", caption="<", style="fatcontroller_button_style"})
		else
			newGui.trainInfoControls.pageButtons.add({type="button", name="page_back", caption="<", style="fatcontroller_disabled_button"})
		end
	end
	
	-- if guiSettings.page > 1 then
		-- newGui.trainInfoControls.pageButtons.page_back.style = "fatcontroller_button_style"
	-- else
		-- newGui.trainInfoControls.pageButtons.page_back.style = "fatcontroller_disabled_button"
	-- end
	
	if newGui.trainInfoControls.pageButtons.page_number == nil then
		newGui.trainInfoControls.pageButtons.add({type="button", name="page_number", caption=guiSettings.page .. "/" .. guiSettings.pageCount, style="fatcontroller_button_style"})
	else
		newGui.trainInfoControls.pageButtons.page_number.caption = guiSettings.page .. "/" .. guiSettings.pageCount
	end
	
	if newGui.trainInfoControls.pageButtons.page_forward == nil then
		if guiSettings.page < guiSettings.pageCount then
			newGui.trainInfoControls.pageButtons.add({type="button", name="page_forward", caption=">", style="fatcontroller_button_style"})
		else
			newGui.trainInfoControls.pageButtons.add({type="button", name="page_forward", caption=">", style="fatcontroller_disabled_button"})
		end
		
	end
	
	-- if guiSettings.page < guiSettings.pageCount then
		-- newGui.trainInfoControls.pageButtons.page_forward.style = "fatcontroller_button_style"
	-- else
		-- newGui.trainInfoControls.pageButtons.page_forward.style = "fatcontroller_disabled_button"
	-- end
	
	if newGui.trainInfoControls.filterButtons == nil then
		newGui.trainInfoControls.add({type = "flow", name="filterButtons",  direction="horizontal", style="fatcontroller_button_flow"})
	end
	
	if newGui.trainInfoControls.filterButtons.toggleStationFilter == nil then
		
		if guiSettings.activeFilterList ~= nil then 
			newGui.trainInfoControls.filterButtons.add({type="button", name="toggleStationFilter", caption="s", style="fatcontroller_selected_button"})
		else
			newGui.trainInfoControls.filterButtons.add({type="button", name="toggleStationFilter", caption="s", style="fatcontroller_button_style"})
		end
	end
	
	if newGui.trainInfoControls.filterButtons.clearStationFilter == nil then
		if guiSettings.activeFilterList ~= nil then 
			newGui.trainInfoControls.filterButtons.add({type="button", name="clearStationFilter", caption="s", style="fatcontroller_selected_button"})
		else
			newGui.trainInfoControls.filterButtons.add({type="button", name="clearStationFilter", caption="s", style="fatcontroller_button_style"})
		end
	end
	
	-- if guiSettings.activeFilterList ~= nil then 
		-- newGui.trainInfoControls.filterButtons.toggleStationFilter.style = "fatcontroller_selected_button"
		-- newGui.trainInfoControls.filterButtons.clearStationFilter.style = "fatcontroller_button_style"
	-- else
		-- newGui.trainInfoControls.filterButtons.toggleStationFilter.style = "fatcontroller_button_style"
		-- newGui.trainInfoControls.filterButtons.clearStationFilter.style = "fatcontroller_disabled_button"
	-- end
	
	
	

	
	return newGui
end

-- function getFirstCarriage(train)
	-- if train ~= nil and train.valid then
		-- for i, carriage in ipairs(train.carriages) do
			-- if carriage ~= nil and carriage.valid and isTrainType(carriage.type) then
				-- return carriage
			-- end
		-- end
	-- end
-- end

function getTrainFromLocomotives(locomotives)
	if locomotives ~= nil then
		for i,loco in ipairs(locomotives) do
			if loco ~= nil and loco.valid and loco.train ~= nil and loco.train.valid then
				return loco.train
			end
		end
	end
end

function isTrainInfoDuplicate(trains, trainInfoB, index)
	--local trainInfoB = trains[index]
	if trainInfoB ~= nil and trainInfoB.train ~= nil and trainInfoB.train.valid then
		for i, trainInfo in ipairs(trains) do
			--debugLog(i)
			if i ~= index and trainInfo.train ~= nil and trainInfo.train.valid and compareTrains(trainInfo.train, trainInfoB.train) then
				return true
			end
		end
	end
	
	
	return false
end

function compareTrains(trainA, trainB)
	if trainA ~= nil and trainA.valid and trainB ~= nil and trainB.valid and trainA.carriages[1].equals(trainB.carriages[1]) then
		return true
	end
	return false
end

function updateTrains(trains)
	if trains ~= nil then
		for i, trainInfo in ipairs(trains) do
			
			--refresh invalid train objects
			if trainInfo.train == nil or not trainInfo.train.valid then
				trainInfo.train = getTrainFromLocomotives(trainInfo.locomotives)
				trainInfo.locomotives = getLocomotives(trainInfo.train)
				if isTrainInfoDuplicate(trains, trainInfo, i) then
					trainInfo.train = nil
				end
			end
			
			if (trainInfo.train == nil or not trainInfo.train.valid) then
				
				table.remove(trains, i)
			else
				trainInfo.locomotives = getLocomotives(trainInfo.train)
				updateTrainInfo(trainInfo)
				--debugLog(trainInfo.train.state)
			end
		end
	end
end

function updateTrainInfoIfChanged(trainInfo, field, value) 
	if trainInfo ~= nil and field ~= nil and trainInfo[field] ~= value then
		trainInfo[field] = value
		trainInfo.updated = true
		return true
	end
	return false
end


function updateTrainInfo(trainInfo)
	if trainInfo ~= nil then
		trainInfo.updated = false
	
		updateTrainInfoIfChanged(trainInfo, "manualMode", trainInfo.train.manualmode)
		updateTrainInfoIfChanged(trainInfo, "speed", trainInfo.train.speed)
		
		--SET CurrentStationText
		if trainInfo.train.schedule ~= nil and trainInfo.train.schedule.current ~= nil and trainInfo.train.schedule.current ~= 0 then
			if trainInfo.train.schedule.records[trainInfo.train.schedule.current] ~= nil then
				updateTrainInfoIfChanged(trainInfo, "currentStation", trainInfo.train.schedule.records[trainInfo.train.schedule.current].station)
			else
				updateTrainInfoIfChanged(trainInfo, "currentStation", "Auto")
			end
		end
		
		--SET InventoryText
		if trainInfo.train.state == 7 or (trainInfo.train.state == 9 and trainInfo.train.speed == 0) then
			local tempInventory = getHighestInventoryCount(trainInfo)
			if tempInventory ~= nil then
				updateTrainInfoIfChanged(trainInfo, "inventory", tempInventory)
			end
		end
		
		-- if openEntity ~= nil and containsEntity(trainInfo.locomotives, openEntity) then
			-- updateTrainInfoIfChanged(trainInfo, "open", true)
		-- else
			-- updateTrainInfoIfChanged(trainInfo, "open", false)
		-- end
		
		-- if followEntity ~= nil and trainInfo.train.carriages[1].equals(followEntity) then
			-- updateTrainInfoIfChanged(trainInfo, "follow", true)
		-- else
			-- updateTrainInfoIfChanged(trainInfo, "follow", false)
		-- end
		
		if trainInfo.train.schedule ~= nil and trainInfo.train.schedule.records ~= nil and trainInfo.train.schedule.records[1] ~= nil then
			trainInfo.stations = {}
			-- if trainInfo.stations == nil then
				
			-- end
			for i, record in ipairs(trainInfo.train.schedule.records) do
				trainInfo.stations[record.station] = true
			end
		else
			trainInfo.stations = nil
		end
	end
end

function containsEntity(entityTable, entityA)
	if entityTable ~= nil and entityA ~= nil then
		for i, entityB in ipairs(entityTable) do
			if entityB ~= nil and entityB.equals(entityA) then
				return true
			end
		end
	end
	return false
end

function refreshTrainInfoGui(trains, guiSettings, character)
	local gui = guiSettings.fatControllerGui.trainInfo
	if gui ~= nil then
		local removeGuiFromCount = 1
		local removeTrainInfo = {}
		
		local pageStart = ((guiSettings.page - 1) * guiSettings.displayCount) + 1
		--debugLog("Page:" .. pageStart)
		
		local display = 0
		local filteredCount = 0
		
		for i, trainInfo in ipairs(trains) do
			local newGuiName = nil
			
			if display < guiSettings.displayCount then
			
				if guiSettings.activeFilterList == nil or trainInfo.matchesStationFilter then
					filteredCount = filteredCount + 1
					
					newGuiName = "Info" .. filteredCount
					
					if filteredCount >= pageStart then
						--removeGuiFromCount = removeGuiFromCount + 1
						display = display + 1
						debugLog(newGuiName)
						if trainInfo.updated or gui[newGuiName] == nil then --trainInfo.guiName ~= newGuiName or
							trainInfo.guiName = newGuiName
							
							if gui[trainInfo.guiName] == nil then
								gui.add({ type="frame", name=trainInfo.guiName, direction="horizontal", style="fatcontroller_thin_frame"})
							end
							local trainGui = gui[trainInfo.guiName]
							
							
							--Add buttons
							if trainGui.buttons == nil then
								trainGui.add({type = "flow", name="buttons",  direction="horizontal", style="fatcontroller_traininfo_button_flow"})
							end
							
							-- if trainGui.buttons[trainInfo.guiName .. "_removeTrain"] == nil then
								-- trainGui.buttons.add({type="button", name=trainInfo.guiName .. "_removeTrain", caption="x", style="fatcontroller_button_style"})
							-- end
							

							if trainGui.buttons[trainInfo.guiName .. "_toggleManualMode"] == nil then
								trainGui.buttons.add({type="button", name=trainInfo.guiName .. "_toggleManualMode", caption="ll", style="fatcontroller_button_style"})
							end
							
							if trainInfo.manualMode then 
								trainGui.buttons[trainInfo.guiName .. "_toggleManualMode"].caption = ">"
							else
								trainGui.buttons[trainInfo.guiName .. "_toggleManualMode"].caption = "ll"
							end
							
							
							if trainGui.buttons[trainInfo.guiName .. "_toggleFollowMode"] == nil then
								trainGui.buttons.add({type="button", name=trainInfo.guiName .. "_toggleFollowMode", caption={"text-controlbutton"}, style="fatcontroller_button_style"})
							end
							

							--Add info
							if trainGui.info == nil then
								trainGui.add({type = "flow", name="info",  direction="vertical", style="fatcontroller_thin_flow"})
							end
							
							
							
							if trainGui.info.topInfo == nil then
								trainGui.info.add({type="label", name="topInfo", style="fatcontroller_label_style"})
							end
							if trainGui.info.bottomInfo == nil then
								trainGui.info.add({type="label", name="bottomInfo", style="fatcontroller_label_style"}) 
							end
							
							local topString = ""
							
							if trainInfo.manualMode then
								topString = "Manual" -- REPLACE WITH TRANSLAION
							elseif trainInfo.currentStation ~= nil then
								topString = trainInfo.currentStation
							end
							
							if trainInfo.speed == 0 then
								topString = topString .. ": " .. "Stopped" -- REPLACE WITH TRANSLAION
							else
								topString = topString .. ": " .. "Moving" -- REPLACE WITH TRANSLAION
							end
							
							
							local bottomString = ""
							
							if trainInfo.inventory ~= nil then
								bottomString = trainInfo.inventory
							else
								bottomString = ""
							end
							
							trainGui.info.topInfo.caption = topString
							trainGui.info.bottomInfo.caption = bottomString
						end
						
						-- if character ~= nil and containsEntity(trainInfo.locomotives, character.opened) then --character.opened ~= nil and
							-- gui[newGuiName].buttons[trainInfo.guiName .. "_removeTrain"].style = "fatcontroller_selected_button"
						-- else
							-- --debugLog("Failed: " .. i)
							-- gui[newGuiName].buttons[trainInfo.guiName .. "_removeTrain"].style = "fatcontroller_button_style"
						-- end
						
						if character ~= nil and character.name == "fatcontroller" and containsEntity(trainInfo.locomotives, character.vehicle) then
							gui[newGuiName].buttons[newGuiName .. "_toggleFollowMode"].style = "fatcontroller_selected_button"
						else
							gui[newGuiName].buttons[newGuiName .. "_toggleFollowMode"].style = "fatcontroller_button_style"
						end
						
					end
				end
			end
			if newGuiName == nil and trainInfo.guiName ~= nil and gui.newGuiName ~= nil then 
				gui.destroy()
			end
			trainInfo.guiName = newGuiName
		end
		
		--debugLog("display: " .. display .. " fc: " .. filteredCount .. " removeCount: " .. removeGuiFromCount)
		
		-- for i, number in ipairs(trainsToRemove) do
			-- table.remove(trains, number)
		-- end
		-- removeGuiFromCount = display
		-- while gui["Info" .. removeGuiFromCount] ~= nil do
			-- gui["Info" .. removeGuiFromCount].destroy()
			-- removeGuiFromCount = removeGuiFromCount + 1
		-- end
	end
end

function filterTrainInfoList(trains, activeFilterList)
	if trains ~= nil  then
		for i,trainInfo in ipairs(trains) do
			if activeFilterList ~= nil then
				trainInfo.matchesStationFilter = matchStationFilter(trainInfo, activeFilterList) 
				if trainInfo.matchesStationFilter then
					--debugLog("MATCH!: " .. i)
				end
			else
				trainInfo.matchesStationFilter = true
			end
		end

	end
	
end

function matchStationFilter(trainInfo, activeFilterList)
	local fullMatch = false
	if trainInfo ~= nil and trainInfo.stations ~= nil then
		for filter, value in pairs(activeFilterList) do
			if trainInfo.stations[filter] then
				fullMatch = true
			else 
				return false
			end
		end
	end
	
	return fullMatch
end

-- function findTrainInfoFromEntity(trains, entity)
	-- for i, trainInfo in ipairs(trains) do
		-- if train ~= nil and train.valid and train.carriages[1] ~= nil and trainInfo ~= nil and trainInfo.train.carriages[1] ~= nil and entity.equals(trainB.train.carriages[1]) then
			-- return trainInfo
		-- end
	-- end
-- end

function trainInList(trains, train)
	for i, trainInfo in ipairs(trains) do
		if train ~= nil and train.valid and train.carriages[1] ~= nil and trainInfo ~= nil and trainInfo.train ~= nil and trainInfo.train.valid and trainInfo.train.carriages[1] ~= nil and train.carriages[1].equals(trainInfo.train.carriages[1]) then
			return true
		end
	end
	return false
end

-- function addNewTrainGui(gui, train)
	-- if train ~= nil and train.valid and train.carriages[1] ~= nil and train.carriages[1].valid then
		-- if gui.toggleTrain ~= nil then
			-- gui.toggleTrain.destroy()
		-- end
		
	-- end
-- end

function matchStringInTable(stringA, tableA)
	for i, stringB in ipairs(tableA) do
		if stringA == stringB then
			return true
		end
	end
	return false
end

function round(num, idp)
  local mult = 10^(idp or 0)
  return math.floor(num * mult + 0.5) / mult
end

function debugLog(message)
	if false then -- set for debug
		for i,player in ipairs(game.players) do
			player.print(message)
		end
	end
end

function endsWith(String,End)
   return End=='' or string.sub(String,-string.len(End))==End
end

function startsWith(String,Start)
	debugLog(String)
	debugLog(Start)
   return string.sub(String,1,string.len(Start))==Start
end

function pairsByKeys (t, f)
	local a = {}
	for n in pairs(t) do table.insert(a, n) end
	table.sort(a, f)
	local i = 0      -- iterator variable
	local iter = function ()   -- iterator function
		i = i + 1
		if a[i] == nil then return nil
			else return a[i], t[a[i]]
		end
	end
	return iter
end